local addonName = ...
local f = CreateFrame("Frame", "WorldEvents", UIParent) -- main frame
local info = {}
local config, realm, char, options, c
local playerName, realmName = GetUnitName"player", GetRealmName()
local shortcuts, workingFrame, prevAltSkill
local baseScript, SetTracking
local L = setmetatable( select(2, ...), { __index = function(t,k) return k end, __call = function(t,k) return t[k] end } )
local Menu_OnEnter, Menu_OnLeave,tip
local defaultColors = { header={1,1,1}, activeName={1,.82,0}, infoName={.6,.5,0}, selected={.9,0.45,.1}, highlight={1,.8,0}, ownCD={1,.82,0}, foreignCD={.6,.5,0} }
local AUTO = "AUTO"
local LSM = LibStub("LibSharedMedia-3.0")
LSM:Register("sound", "Blizzard: Alarm Clock 1",    "Sound\\Interface\\AlarmClockWarning1.wav")
LSM:Register("sound", "Blizzard: Alarm Clock 2",    "Sound\\Interface\\AlarmClockWarning2.wav")
LSM:Register("sound", "Blizzard: Alarm Clock 3",    "Sound\\Interface\\AlarmClockWarning3.wav")
local  AlertChimeFile = "Blizzard: Alarm Clock 3"

local events = {
	TrickOrTreat={ TrickedCD = 24755,SpellTreat = 24715,SpellTrick = 24714 },--Treat Bag,Trick or Treated debuff
	Pumpkin=54516, --Item from killing the Headless Horseman
	Smash =36876, --Scorched Holy Symbol
	Loot= { Helm=33292,Pet=33154,Mount=37012,Broom=33176 },
	None =			0
}

local groupIcons = {
	["Transmutes"] = "Interface\\Icons\\Spell_Nature_ElementalPrecision_2"
}

local HOUR, DAY = 3600, 86400



function f:UNIT_AURA(event,Unit)

if event ~= "UNIT_AURA" then return end

if( Unit == "player" ) then
	for i=1,40 do
		-- Tricked or Treated  Interface\Icons\INV_Misc_Food_59 0 nil 3600.001 1758109.289 player nil nil 24755 false nil
		-- /script name,  icon, count, debuffType,_, duration, expireTime, isMine,_,_,DebuffID,_,_ = UnitAura("player", 1, "HARMFUL"); print(DebuffID);
		 local name,  icon, count, debuffType,_, duration, expireTime, isMine,_,_,DebuffID,_,_ = UnitAura("player", i, "HARMFUL")
	 
		if(DebuffID ~= nil ) then
			--print(string.format("Found Event=%s DebuffID=%d duration=%d expireTime=%d",event,DebuffID,duration,expireTime))
			if( DebuffID == events.TrickOrTreat.TrickedCD ) then
				--print(string.format("Trick or Treated DebuffID=%d duration=%d expireTime=%d",DebuffID,duration,expireTime))
				realm[playerName].tricked.expireTime= time() + (expireTime - GetTime())
			end
		else
			return
		end
	end
end
end
function f:UNIT_SPELLCAST_STOP(event, unit, spell,rank,lineID,spellid)
	if unit ~= "player" then return end
	--or spell ~= watchedSpell
	--f:UnregisterEvent"UNIT_SPELLCAST_SUCCEEDED"
	--f:UnregisterEvent"UNIT_SPELLCAST_STOP"
	if event ~= "UNIT_SPELLCAST_SUCCEEDED" then return end
	
	if( spellid == events.TrickOrTreat.SpellTreat ) then
		--print(string.format("Treated unit=%s,spell=%s,rank=%s,lineID=%d,spellid=%d",unit,spell,rank,lineID,spellid))
		realm[playerName].tricked.GotBag=1;
	end
	if( spellid == events.TrickOrTreat.SpellTrick ) then
		--print(string.format("Tricked unit=%s,spell=%s,rank=%s,lineID=%d,spellid=%d",unit,spell,rank,lineID,spellid))
		realm[playerName].tricked.GotBag=0;
	end
	--print(string.format("UNIT_SPELLCAST_STOP unit=%s,spell=%s,rank=%s,lineID=%d,spellid=%d",unit,spell,rank,lineID,spellid))
end
f.UNIT_SPELLCAST_SUCCEEDED = f.UNIT_SPELLCAST_STOP

local matchPushedItem = LOOT_ITEM_PUSHED_SELF:gsub("(%%s)", "(.+)") -- LOOT_ITEM_SELF for corpse loot
local matchLootedItem = LOOT_ITEM_SELF:gsub("(%%s)", "(.+)")
function f:CHAT_MSG_LOOT(event, msg)
	local item = msg:match(matchLootedItem)
	if not item then
		--print(string.format("CHAT_MSG_LOOT returning event=%s,msg=%s",event,msg))
		item = msg:match(matchPushedItem)
	end
	
	if not item then
		return
	end
	local name, id, cd, _, _, _, _, _, _, texture = GetItemInfo(item)
	id = tonumber( id:match"(%d+):" )
	    if( id == events.Loot.Helm ) then
		realm[playerName].Loot.Helm=1
	elseif( id == events.Loot.Pet ) then
		realm[playerName].Loot.Pet=1
	elseif( id == events.Loot.Mount ) then
		realm[playerName].Loot.Mount=1
	elseif( id == events.Loot.Broom ) then
		realm[playerName].Loot.Broom=1
	elseif( id == events.Pumpkin ) then
		realm[playerName].KilledHorseman=time()
	elseif( id == events.Smash ) then
		realm[playerName].Smash=time()
	end
	
	--print(string.format("CHAT_MSG_LOOT event=%s,msg=%s,id=%d",event,msg,id))
end

local md, mx, xx, dd = 20*HOUR, 3*DAY+20*HOUR, { DAY, HOUR, 60, 1 }, { L.d, L.h, L.m, L.s }
local function SecondsToTime(s)
	--print(string.format("Got s=%d",s))
	local p = s<md and s/md*.5 or s<mx and (s-md)/(mx-md)*.5+.5 or 1
	local i = s>=DAY and 1 or s>=HOUR and 2 or 3
	return ("|cff%.2x%.2x40%i%s %.2i%s|r"):format(
		p<.5 and 64+p*382 or 255, p<.5 and 255 or 446-p*382,
		floor(s/xx[i]), dd[i], floor((s%xx[i])/xx[i+1]), dd[i+1] )
end

local function ColorCurMax(cur,max,isProfession)
	local pMax = isProfession and min(max/450,1) or 1
	local pCur = isProfession and 1-min(sqrt(max-cur)/10,1) or 2/sqrt(max-cur+4)
	return ("|cff%.2x%.2x00%.3i|r / |cff%.2x%.2x00%.3i|r"):format(
		pCur<.5 and 255 or 510-pCur*510, pCur<.5 and pCur*510 or 255, cur,
		pMax<.5 and 255 or 510-pMax*510, pMax<.5 and pMax*510 or 255, max )
end

function bton(bool)
	if( bool == true) then
		return 1
	else
		return 0
	end
end

Menu_OnLeave = function(self)
	if not f:IsMouseOver() then
		f:Hide()
	end
end



function f:ADDON_LOADED(event, addon)
	
	
	if addon ~= addonName then return end	

	BrokerWorldEventsDB = BrokerWorldEventsDB or {icons={},names={},aliases={},colors=defaultColors}
	config = BrokerWorldEventsDB
	
	if not config.scale then config.scale = 1 end
	if not config.DisableAlarm then config.DisableAlarm = 0 end
	if not config.AlarmEvery then config.AlarmEvery=300 end
	if not config.DisableSoundAlarm then config.DisableSoundAlarm=1 end

	if not config[realmName] then config[realmName] = {} end

	realm = config[realmName]
	
	local _, player_class = UnitClass("player")
	
	if not realm[playerName] then
		realm[playerName] = {
					charName=playerName,
					icon = CLASS_ICON_TCOORDS[player_class or "WARRIOR"] or CLASS_ICON_TCOORDS["WARRIOR"],
					tricked={expireTime=0,GotBag=0}, --0=Debuf 1=Bag
					KilledHorseman=0,--time when killed
					Smash=0,--time when completed quest
					Loot= { Helm=0,Pet=0,Mount=0,Broom=0 },
					ignore = 0 -- alarm ignore boolean
				}
	end
	
	char = realm[playerName]
	
	
	if not char.icon then char.icon = CLASS_ICON_TCOORDS[player_class or "WARRIOR"] or CLASS_ICON_TCOORDS["WARRIOR"] end
	if char.ignore == nil then char.ignore = 0 end
	
	print("WorldEvents: Hallow's End tracker by bruj0 v0.3.2")
	
	--print("Info so far: ")
	for k,v in pairs(realm) do
		--v.tricked.expireTime
		local now = time()
		local dend=v.tricked.expireTime - now
		local khorseman=now - v.KilledHorseman
		
		if( dend < 0  or v.tricked.expireTime == 0) then
			dend=0
			print(string.format("|cffff4040WorldEvents:|r%s can Trick or Treat |cff20ff20Now!|r",v.charName))
		end
		
--[[	
		if( khorseman < 0 or v.KilledHorseman == 0 ) then
			khorseman=0
			print(string.format("|cffff4040WorldEvents:|r%s timer for Headless Horseman is up, he might be able to queue |cff20ff20Now!|r",v.charName))
		end
		print("---")
--]]
		--print(string.format("douing %d - %d=%d",v.tricked.expireTime,now,dend))
		--print(string.format("Character name=%s tricked expireTime=%s,GotBag=%d",v.charName,SecondsToTime(dend),v.tricked.GotBag))
		--print(string.format("Killed Horseman on: %s %d",SecondsToTime(khorseman),v.KilledHorseman))
		--print(string.format("Loot so far: Helm=%d, Pet=%d,Mount=%d,Brrom=%d",v.Loot.Helm,v.Loot.Pet,v.Loot.Mount,v.Loot.Broom))
		--print("---")
	end
	
	tip = _G.GameTooltip
	self:SetFrameStrata"TOOLTIP"
	self:SetClampedToScreen(true)
	self:EnableMouse(true)
	self:SetScript("OnLeave", Menu_OnLeave)
	
	f:RegisterEvent("CHAT_MSG_LOOT")
	f:RegisterEvent("UNIT_AURA")
	f:RegisterEvent"UNIT_SPELLCAST_SUCCEEDED"
	f:RegisterEvent"UNIT_SPELLCAST_STOP"


	if IsLoggedIn() then update_data() else
		f.PLAYER_ENTERING_WORLD = update_data
		f:RegisterEvent"PLAYER_ENTERING_WORLD"
	end

	local backdrop = { bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		tile=false, tileSize=0, edgeSize=14, insets = { left=3, right=3, top=3, bottom=3 } }
	self:SetBackdrop(backdrop)
	self:SetBackdropColor(.1, .1, .1, .8)
	self:SetBackdropBorderColor(.3, .3, .3, .9)
	
	self:UnregisterEvent(event)
	self.ADDON_LOADED = nil	

	
end
local Buttons= {}

local BUTTON_HEIGHT, ICON_SIZE, GAP, TEXT_OFFSET = 17, 15, 10, 4
local maxWidth = 0

Menu_OnEnter = function (self)
	local height = 0
	
	workingFrame = f
	
	
	f:Show()
	
	if(#Buttons == 0) then
		local width , button
		for k,v in pairs(realm) do
			-- if not v.icon then v.icon="Interface\\Icons\\INV_Misc_Food_59"
			
			width , button = createButton(v.charName,#Buttons+1,v.icon) 
			tinsert(Buttons, button)
			height = height + BUTTON_HEIGHT
			if(width > maxWidth) then maxWidth = width end
		end
	
	f:SetWidth(maxWidth+50)
	f:SetHeight(height + (BUTTON_HEIGHT*2))
	f:ClearAllPoints()
	f:SetPoint("TOP",self,"BOTTOM")
	end
	
end


f.block = LibStub("LibDataBroker-1.1"):NewDataObject("WorldEvents", {
	type = "data source",
	text = "WorldEvents - Hallow's End",
	icon = "Interface\\Icons\\INV_Misc_Food_59",
	iconCoords = { 0.075, 0.925, 0.075, 0.925 },
	OnEnter = Menu_OnEnter,
	OnLeave = Menu_OnLeave,

} )


function yon(val)
	if(val == 0 ) then
		return "|cffff4040No"
	else
		return "|cff20ff20Yes"
	end
end


local totalElapsed = 0.0;
--local AlarmEvery=5--300 --5 min in secods

local function onUpdateAlarm(self, elapsed)
	if(config.DisableAlarm==1) then return end
	totalElapsed = totalElapsed + elapsed;
  
	  local mod=totalElapsed%config.AlarmEvery
	  
  
	   if ( (mod < 1) and (totalElapsed >config.AlarmEvery )) then
		local playsound=0
		totalElapsed = totalElapsed + 1;
		for k,v in pairs(realm) do
			local now = time()
			local dend=v.tricked.expireTime - now
			local khorseman=now - v.KilledHorseman
			
			
			if(v.ignore == nil) then
				v.ignore = 0
			end
		
			if ((v.ignore==0) and ( dend < 0  or v.tricked.expireTime == 0)) then
				dend=0
				print(string.format("|cffff4040WorldEvents:|r%s can Trick or Treat |cff20ff20Now!|r",v.charName))
				playsound=1
			end
--[[	
		if( khorseman < 0 or v.KilledHorseman == 0 ) then
			khorseman=0
			print(string.format("|cffff4040WorldEvents:|r%s timer for Headless Horseman is up, he might be able to queue |cff20ff20Now!|r",v.charName))
		end
		print("---")
--]]
		end
		if ( config.DisableSoundAlarm==0 and playsound==1 ) then
			PlaySoundFile(LSM:Fetch("sound", AlertChimeFile))
		end
		if(playsound==1) then
			print("|cffff4040WorldEvents:|r You can disable this alarm by typing |cff20ff20/we alarm off|r or set the reminder time with |cff20ff20/we alarm XX|r in minutes")
		end
	end
	
		

end

SLASH_WE1, SLASH_WE2 = '/we', '/wehe';
local function handler(msg, editbox)

-- local command, rest = msg:match("^(%S*)%s*(.-)$");
local command
local args = {}


for v in string.gmatch(msg:lower(),"[^ ]+") do
	if v then 
		tinsert(args,v)
	end
end

if (args[1] == 'alarm' ) then
	if( args[2] == 'off') then
		config.DisableAlarm = 1
		print("|cffff4040WorldEvents:|r Alarm |cffff4040Disabled|r")
	elseif( args[2] == 'on' ) then
		config.DisableAlarm = 0
		print("|cffff4040WorldEvents:|r Alarm |cff20ff20Enabled|r")
	elseif( args[2] == 'soundon' ) then
		config.DisableSoundAlarm = 0
		print("|cffff4040WorldEvents:|r Sound on Alarm is |cff20ff20Enabled|r")
	elseif( args[2] == 'soundoff' ) then
		config.DisableSoundAlarm = 1
		print("|cffff4040WorldEvents:|r Sound on Alarm is |cffff4040Disabled|r")
	elseif( args[2] == 'ignore' ) then
		if(args[3]) == 'list' then
			print("|cffff4040WorldEvents:|r List of characters being ignored for the alarm")
			for k,v in pairs(realm) do
				if(v.ignore == 1 ) then
					print(string.format("|cffff4040WorldEvents:|r |cff20ff20%s|r is being |cffff4040ignored|r on the alarm",v.charName))
				end
			end
			print("|cffff4040WorldEvents:|r End of list")
		else
			local found = 0
			for k,v in pairs(realm) do
				if(v.charName:lower()==args[4]:lower()) then
				found = 1
					if( args[3] == 'add') then
						print(string.format("|cffff4040WorldEvents:|r %s added to the |cffff4040ignore|r list for alarms",v.charName))
						v.ignore=1
					elseif( args[3] == 'del') then
						print(string.format("|cffff4040WorldEvents:|r %s removed from the |cffff4040ignore|r  list for the alarms",v.charName))
						v.ignore=0
					end
					break
				end
			end
			if(found == 0) then
				print(string.format("|cffff4040WorldEvents:|r Character %s not found",args[4]))
			end
		end
	else
	
		number=tonumber(args[2])
		if( number ~= nil) then
			config.AlarmEvery=floor(number*60)
			print(string.format("|cffff4040WorldEvents:|r setting Alarm every  |cff20ff20%d|r minutes",number))
		else
			print("|cffff4040WorldEvents:|r Current configuration ")
			if(config.DisableAlarm == 1) then
				print("|cffff4040WorldEvents:|r Alarm is |cffff4040Disabled|r")
			else
				print(string.format("|cffff4040WorldEvents:|r Alarm set to every  |cff20ff20%d|r minutes",floor(config.AlarmEvery/60)))
			end
			if(config.DisableSoundAlarm==1) then
				print("|cffff4040WorldEvents:|r Sound on Alarm is |cffff4040Disabled|r")
			else
				print("|cffff4040WorldEvents:|r Sound on Alarm is |cff20ff20Enabled|r")
				
			end
			
				
		end
	end
else
	print("|cffff4040WorldEvents:|r Usage: ")
	print("|cffff4040WorldEvents:|r /we alarm (current configuration) ")
	print("|cffff4040WorldEvents:|r /we alarm on|off ")
	print("|cffff4040WorldEvents:|r /we alarm [number of minutes] (time between alarm activation)")
	print("|cffff4040WorldEvents:|r /we alarm soundon (alarm sound ON)")
	print("|cffff4040WorldEvents:|r /we alarm soundoff (alarm sound OFF)")
	print("|cffff4040WorldEvents:|r /we alarm ignore list (List characters on the ignore list for alarms)")
	print("|cffff4040WorldEvents:|r /we alarm ignore add [altname] (Add characters)")
	print("|cffff4040WorldEvents:|r /we alarm ignore del [altname] (Delete characters")
end
	
end


function update_data()
 
	f:UNIT_AURA('UNIT_AURA','player')
	
	local criteriaString, criteriaType, completed, quantity, reqQuantity, 
		charName, flags, assetID, quantityString, criteriaID = 
	GetAchievementCriteriaInfo(292, 2); 
	 char.Loot.Helm=bton(completed)

	criteriaString, criteriaType, completed, quantity, reqQuantity, 
		charName, flags, assetID, quantityString, criteriaID = 
	 GetAchievementCriteriaInfo(292, 1);
	char.Loot.Pet=bton(completed)

	local IDNumber, Name, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText =
	GetAchievementInfo(980)
	char.Loot.Mount=bton(Completed)
	
	SlashCmdList["WE"] = handler; -- Also a valid assignment strategy
	
end

local LibQTip = LibStub('LibQTip-1.0')

local function CreateHL(frame)
	local hl = frame:CreateTexture()
	hl:SetTexture"Interface\\QuestFrame\\UI-QuestLogTitleHighlight"
	hl:SetBlendMode"ADD"
	hl:SetWidth(maxWidth)
	hl:SetAlpha(0)
	return hl
end
local highlight = CreateHL(f)



function createButton(alt_name,number,icon)

	local width 
	local button = CreateFrame("Button", nil, workingFrame)
	button:RegisterForClicks"AnyUp"
	button:SetHeight(BUTTON_HEIGHT)
	
	button:SetPoint("TOPLEFT", workingFrame, "TOPLEFT", GAP+10, (number * -BUTTON_HEIGHT))
	button:SetScript("OnEnter",function (self)
					showAlt(self,alt_name)
				   end)
	button:SetScript("OnLeave", function (self)
					hideAlt(self)
				    end)
	button.icon = button:CreateTexture(nil, "OVERLAY")
	button.icon:SetWidth(ICON_SIZE) button.icon:SetHeight(ICON_SIZE)
	button.icon:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
	button.icon:SetPoint("LEFT", button, "LEFT")
	--button.icon:SetTexCoord(0.075, 0.925, 0.075, 0.925)
	if not icon then
		icon = CLASS_ICON_TCOORDS["WARRIOR"] or CLASS_ICON_TCOORDS["WARRIOR"]
	end
	button.icon:SetTexCoord(icon[1] + 0.015, icon[2] - 0.015, icon[3] + 0.02, icon[4] - 0.02)

	button.fontLeft = button:CreateFontString(nil, "OVERLAY", "SystemFont_Shadow_Med1")
	button.fontLeft:SetPoint("LEFT", button, "LEFT", TEXT_OFFSET + ICON_SIZE, 0)
	button.fontLeft:SetText(alt_name)
	button.fontLeft:SetTextColor(1,.82,0)
	width = button.fontLeft:GetStringWidth()
	button:SetWidth(width)
	button.light = highlight
	button:Show()
	return width, button
end

function hideAlt(self)
   LibQTip:Release(self.tooltip)
   self.tooltip = nil
end
function showAlt(self,name)

highlight:SetAllPoints(self)
highlight:SetAlpha(1)

local stip = LibQTip:Acquire("WEsubTooltip", 2, "LEFT","CENTER")
self.tooltip = stip
	for k,v in pairs(realm) do
	
		if(v.charName == name) then
			local now = time()
			local dend=v.tricked.expireTime - now
			local khorseman=now - v.KilledHorseman
			local smash=now - v.Smash
			local l,c
			
			if( dend < 0  or v.tricked.expireTime == 0) then
				ToT="|cff20ff20Now!"
				
			else
				ToT=SecondsToTime(dend)
			end
		
			if( khorseman < 0 or v.KilledHorseman == 0 ) then
				kh="|cff20ff20Never!"
			else
				kh=SecondsToTime(khorseman)
			end
			
			if ( smash < 0 or v.Smash ==0 ) then
				st="|cff20ff20Never!"
			else
				st=SecondsToTime(smash)
			end
			
			l,c = stip:AddHeader("Char:",string.format("|cffffd100%s|r",v.charName))
			stip:SetLineColor(l,0,0,0)
			stip:AddLine("Next ToT:",ToT)
			stip:AddLine("Got bag last time?",yon(v.tricked.GotBag))
			stip:AddLine("Last Horseman Kill on:",kh)
			stip:AddLine("Last Quest done:",st)
			stip:AddLine("Has Hallowed Helm",yon(v.Loot.Helm))
			stip:AddLine("Has Horseman Reins",yon(v.Loot.Mount))
			stip:AddLine("Has Pet",yon(v.Loot.Pet))
			stip:AddLine("Has Broom",yon(v.Loot.Broom))
			stip:Show()
			stip:ClearAllPoints()
			stip:SetClampedToScreen(true)
			stip:SetPoint("LEFT",f,"RIGHT",0,-50)
			
			return;
		end
			
	end
end



f:SetScript("OnUpdate", onUpdateAlarm);
f:SetScript("OnEvent", function(self, event, ...) return self[event](self, event, ...) end)
f:RegisterEvent"ADDON_LOADED"
